'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = coreInit;

var _loadCore = require('./loadCore');

var _loadCore2 = _interopRequireDefault(_loadCore);

var _operations = require('./operations');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function coreInit(opts) {
  if (!window._core) {
    // We're running in a top level script.
    // Load the first core and attach it.
    return (0, _loadCore2.default)(opts, document).then(function (coreRef) {
      (0, _operations.attachCore)(coreRef.context, document);
      return coreRef;
    });
  }

  var core = {
    id: window._core.id,
    args: window._core.args,
    ready: function ready(handlers) {
      return window._core.onReady(handlers);
    }
  };

  try {
    opts.run(core);
  } catch (err) {
    window._core.onExecutionError(err);
    throw err;
  }
}