'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.destroyCore = destroyCore;
exports.detachCore = detachCore;
exports.attachCore = attachCore;
exports.swapCore = swapCore;

var _noop = require('./utils/noop');

var _noop2 = _interopRequireDefault(_noop);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function destroyCore(context) {
  var coreData = context._core;
  coreData.onReady = coreData.onExecutionError = coreData.onLoadError = _noop2.default;
  context.frameElement.parentNode.removeChild(context.frameElement);
}

function detachCore(context, uidocument) {
  context.frameElement.removeAttribute('data-core-active');
  context._core.detach(uidocument);
}

function attachCore(nextContext, uidocument) {
  nextContext.frameElement.setAttribute('data-core-active', '');
  nextContext._core.attach(uidocument);
}

function swapCore(context, nextContext, uidocument) {
  detachCore(context, uidocument);
  attachCore(nextContext, uidocument);
  destroyCore(context);
}